function vrwmScan1_tick_fcn(object,event)

userdata=object.userdata;

userdata.i=userdata.i+1;
userdata.frameNumIter=userdata.frameNumIter+1;

% load environment data
trial=userdata.trial;
pfPause=userdata.pfPause;
SR=userdata.SR;
holdState=userdata.holdState;
nodes=userdata.nodes;
pfXOver=userdata.pfXOver;
pfYOver=userdata.pfYOver;
pfXNovel=userdata.pfXNovel;
pfYNovel=userdata.pfYNovel;
yCoordOver=userdata.yCoordOver;
xCoordOver=userdata.xCoordOver;
dirOver=userdata.dirOver;
yCoordNovel=userdata.yCoordNovel;
xCoordNovel=userdata.xCoordNovel;
dirNovel=userdata.dirNovel;
keySetup=userdata.keySetup;
posStep=userdata.posStep;
rotStep=userdata.rotStep;
radius=userdata.radius;
pfSize=userdata.pfSize;
trialState=userdata.trialState;
pfFrame=userdata.pfFrame;
spIterOver=userdata.spIterOver;
spIterNovel=userdata.spIterNovel;
pfIterNovel=userdata.pfIterNovel;
pfIterFindCount=userdata.pfIterFindCount;
noTimeOut=userdata.noTimeOut;
timeOutPause=userdata.timeOutPause;
pulseReg=userdata.pulseReg;
aPress=userdata.aPress;
maxTrialLength=userdata.maxTrialLength;
nrTrials=userdata.nrTrials;
keysAtOnce=userdata.keysAtOnce;
probePhase=userdata.probePhase;
probePhaseOneComplete=userdata.probePhaseOneComplete;
novelCueWall=userdata.novelCueWall;
fixedCueWall=userdata.fixedCueWall;
blankWall1=userdata.blankWall1;
blankWall2=userdata.blankWall2;
timeOutWall=userdata.timeOutWall;
endRun=userdata.endRun;
successWall=userdata.successWall;
predictErrorWall=userdata.predictErrorWall;
restPauseLow=userdata.restPauseLow;
restPauseHigh=userdata.restPauseHigh;
restPause=userdata.restPause;
maxFramesLow=userdata.maxFramesLow;
maxFramesHigh=userdata.maxFramesHigh;
trialType=userdata.trialType;
currentTrialType=userdata.currentTrialType;
pressNr=userdata.pressNr;
endPress=userdata.endPress;
redGuessWall=userdata.redGuessWall;
redGuessWallTime=userdata.redGuessWallTime;
feedbackPause=userdata.feedbackPause;
cuePause=userdata.cuePause;
mapFolder=userdata.mapFolder;
novelTargetZoneHigh=userdata.novelTargetZoneHigh;
novelTargetZoneLow=userdata.novelTargetZoneLow;
initialiseNovelPf1=userdata.initialiseNovelPf1;
initialiseNovelPf2=userdata.initialiseNovelPf2;
entryFrameNum=userdata.entryFrameNum;
delayFrames=userdata.delayFrames;
novelPfSet = userdata.novelPfSet;
maxNovelRadius = userdata.maxNovelRadius;
runNr=userdata.runNr;

% set keycodes
if keySetup==1
    keycodes=[100 104 102]; % Left Up Right numeric arrow keys
elseif keySetup==2
    keycodes=[74 75 76]; % j k l
elseif keySetup==3
    keycodes=[89 71 82]; % color codes for response box in scanner
end

% create new camera position and rotation
newpos=[];
newrot=[];

% load required nodes
cam=nodes.cam;
platform=nodes.platform;
wallOneTexture=nodes.wallOneTexture;
wallTwoTexture=nodes.wallTwoTexture;
wallThreeTexture=nodes.wallThreeTexture;
wallFourTexture=nodes.wallFourTexture;
feedbackTran1=nodes.feedbackTran1;
feedbackTran2=nodes.feedbackTran2;
textMessage1=nodes.textMessage1;
textMessage2=nodes.textMessage2;
fixationCross=nodes.fixationCross;

% get camera position
pos=cam.position;
x=pos(3);
y=pos(1);
rot=cam.orientation;

% evaluate if end of trial pause is required
if trialState == 3 && userdata.i <= restPause && userdata.frameNumIter < maxFramesLow
    trialState = 3;

    % cue next trial for 2 seconds (50 frames)
    if trialState == 3 && userdata.i == restPause-cuePause

        % remove fixation cross
        fixationCross.translation=[0 -150 -.25];

        % set feedback
        feedbackTran1.translation=[0 -99.985 -.25];
        feedbackTran1.rotation=[0 1 0 0];
        feedbackTran2.translation=[0 -100.015 -.25];
        feedbackTran2.rotation=[0 1 0 0];

        if trialType == 1
            textMessage1.string='SEARCH';
            textMessage2.string='';
        elseif trialType == 2
            textMessage1.string='PREDICTION';
            textMessage2.string='';
        elseif trialType == 3
            textMessage1.string='Target: HIDDEN NOVEL';
            textMessage2.string='Trial: SEARCH';
        elseif trialType == 4
            textMessage1.string='Target: HIDDEN NOVEL';
            textMessage2.string='Trial: PREDICTION';
        end

    end


elseif trialState == 3 && userdata.i == restPause+1

    if userdata.frameNumIter < maxFramesLow
        userdata.i = 1;
        trial = trial+1;
        pfFrame = 0;
        trialState = 1;
        pressNr = 0;

        if trialType == 1 || trialType == 2
            spIterOver = spIterOver+1;
            % reset the scene, sp and trialState
            cam.position=[yCoordOver(spIterOver,1) .85 xCoordOver(spIterOver,1)];
            cam.orientation=[0 1 0 dirOver(spIterOver,1)];
            % store new position
            y=yCoordOver(spIterOver,1);
            x=xCoordOver(spIterOver,1);
            rot(4)=dirOver(spIterOver,1);
        elseif trialType == 3 || trialType == 4
            spIterNovel = spIterNovel+1;
            % reset the scene, sp and trialState
            cam.position=[yCoordNovel(spIterNovel,1) .85 xCoordNovel(spIterNovel,1)];
            cam.orientation=[0 1 0 dirNovel(spIterNovel,1)];
            % store new position
            y=yCoordOver(spIterNovel,1);
            x=xCoordOver(spIterNovel,1);
            rot(4)=dirOver(spIterNovel,1);
        end

        %return cue search wall
        if trialType == 1 || trialType == 2
            wallOneTexture.url=fixedCueWall;
        elseif trialType == 3 || trialType == 4
            wallOneTexture.url=novelCueWall;
        end

        % return remaining search walls
        wallTwoTexture.url=blankWall2;
        wallThreeTexture.url=blankWall1;
        wallFourTexture.url=blankWall2;

    elseif userdata.frameNumIter >= maxFramesLow
        endRun=1;
    end

end

% evaluate if time out is required and hold when true
if noTimeOut == 0 && userdata.i == (((maxTrialLength) - (timeOutPause*SR))+1)
    % set time out state
    trialState = 9;
    % set time out red wall
    wallOneTexture.url=timeOutWall;
    wallTwoTexture.url=timeOutWall;
    wallThreeTexture.url=timeOutWall;
    wallFourTexture.url=timeOutWall;
    % set hold state
    holdState = 9;

elseif holdState == 9 && userdata.i == (((maxTrialLength) - (timeOutPause*SR))+feedbackPause)
    % set time out state
    trialState = 9;

    %return cue search wall
    if trialType == 1 || trialType == 2
        wallOneTexture.url=fixedCueWall;
    elseif trialType == 3 || trialType == 4
        wallOneTexture.url=novelCueWall;
    end

    % return remaining search walls
    wallTwoTexture.url=blankWall2;
    wallThreeTexture.url=blankWall1;
    wallFourTexture.url=blankWall2;

    % set hold state
    holdState = 9;

elseif holdState == 9 && userdata.i <= maxTrialLength
    trialState = 9;

elseif holdState == 9 && userdata.i == maxTrialLength + 1
    if userdata.frameNumIter < maxFramesLow
        userdata.i = 1;
        trialState = 3;
        holdState = 0;
        noTimeOut = 0;

        % set next trial type
        if trialType == 1 && endPress == 0
            trialType = 1;
        elseif trialType == 2 || trialType == 1 && endPress == 1
            trialType = 1;
        elseif trialType == 3 && endPress == 0
            trialType = 3;
        elseif trialType == 4 || trialType == 3 && endPress == 1
            trialType = 1;
        end

        pressNr = 0;
        endPress = 0;

        % remove previous feedback
        feedbackTran1.translation=[0 -150 -.25];
        feedbackTran2.translation=[0 -150 -.25];

        % set position and orientation
        cam.position=[0 -100 0];
        cam.orientation=[0 1 0 0];
        fixationCross.translation=[0 -100 -.25];
        fixationCross.rotation=[0 1 0 0];
        x=cam.position(3);
        y=cam.position(1);
        rot(4)=cam.orientation(4);

        restPause = round((restPauseLow + ((restPauseHigh-restPauseLow)*randn))*SR)+cuePause;

    elseif userdata.frameNumIter >= maxFramesLow
        endRun=1;
    end

end

% check for and evaluate keyboard input
[pressed b check]=KbCheck;
if pressed == 1

    keys=find(check==1);

    if ~isempty(keys(keys==84))   % set value to scan pulse code
        pulseReg(userdata.frameNumIter,1) = 1;
    end

    if ~isempty(keys(keys==27)) % Esc aborts program
        % stop this script
        stop(object)
        % close window
        close(userdata.w)
        % show cursor
        ShowCursor
    end

    if (trialState == 1) && (userdata.i ~= 1)

        if ~isempty(keys(keys==65))    % check for expectation
            aPress(userdata.frameNumIter,1) = 1;
            if aPress(userdata.frameNumIter-1,1) == 0;
                pressNr = pressNr+1;
            end

            % show red walls after incorrect guess
            if (trialType == 2 && (sqrt((pos(3)-pfXOver)^2+(pos(1)-pfYOver)^2)>=pfSize) ...
                    && aPress(userdata.frameNumIter,1) == 1 && pressNr <= 3) ...
                    || (trialType == 4 && (sqrt((pos(3)-pfXNovel)^2+(pos(1)-pfYNovel)^2)>=pfSize) ...
                    && aPress(userdata.frameNumIter,1) == 1 && pressNr <= 3)

                redGuessWall = 1;
                redGuessWallTime = userdata.i;

                % set orange walls
                wallOneTexture.url=predictErrorWall;
                wallTwoTexture.url=predictErrorWall;
                wallThreeTexture.url=predictErrorWall;
                wallFourTexture.url=predictErrorWall;

            end

            if trialType == 2 && pressNr >= 3
                trialType = 1;
                endPress = 1;
            elseif trialType == 4 && pressNr >= 3
                trialType = 3;
                endPress = 1;
            end

        end

        if ~isempty(keys(keys==keycodes(1))) && length(keys) - pulseReg(userdata.frameNumIter,1) <= keysAtOnce % left
            newrot=rot;
            newrot(4)=rot(4)+rotStep;
        end

        if ~isempty(keys(keys==keycodes(3))) && length(keys) - pulseReg(userdata.frameNumIter,1) <= keysAtOnce % right
            newrot=rot;
            newrot(4)=rot(4)-rotStep;
        end

        if ~isempty(keys(keys==keycodes(2))) && length(keys) - pulseReg(userdata.frameNumIter,1) <= keysAtOnce % forward
            rotXY=rot(4);
            newpos=pos;
            x=pos(3)-(posStep*cos(rotXY));
            y=pos(1)-(posStep*sin(rotXY));
            if sqrt(x^2+y^2)+posStep<(radius-radius/50)
                newpos(3)=x;
                newpos(1)=y;
            else
                newpos(3)=pos(3);
                newpos(1)=pos(1);
            end
        end
        
        % set pf position on novel trial
        if novelPfSet == 0 && ~isempty(keys(keys==keycodes(2))) && trialType == 3 && initialiseNovelPf1 == 1 ...
                && sqrt((x-0)^2+(y-0)^2) < maxNovelRadius
            pfXNovel = x;
            pfYNovel = y;
            novelPfSet = 1;
        end

        % show platform when found and initiate trialState for platform pause
        if (trialType == 1 && (sqrt((pos(3)-pfXOver)^2+(pos(1)-pfYOver)^2)<pfSize))  ...
                || (trialType == 2 && (sqrt((pos(3)-pfXOver)^2+(pos(1)-pfYOver)^2)<pfSize) ...
                && aPress(userdata.frameNumIter,1) == 1 && pressNr <= 3) ...
                || (trialType == 3 && (sqrt((pos(3)-pfXNovel)^2+(pos(1)-pfYNovel)^2)<pfSize))  ...
                || (trialType == 4 && (sqrt((pos(3)-pfXNovel)^2+(pos(1)-pfYNovel)^2)<pfSize) ...
                && aPress(userdata.frameNumIter,1) == 1 && pressNr <= 3)

            % set sucess wall colour
            wallOneTexture.url=successWall;
            wallTwoTexture.url=successWall;
            wallThreeTexture.url=successWall;
            wallFourTexture.url=successWall;
            
            currentTrialType = trialType;

            % set next trial type
            if trialType == 1 && endPress == 0
                trialType = 2;
            elseif trialType == 2 || trialType == 1 && endPress == 1
                trialType = 1;
            elseif trialType == 3 && endPress == 0
                trialType = 4;
                pfIterFindCount = pfIterFindCount+1;
            elseif trialType == 4 || trialType == 3 && endPress == 1
                trialType = 1;
            end

            trialState = 2;
            pfFrame = userdata.i;
            noTimeOut = 1;
            pressNr = 0;
            endPress = 0;

        end

    end

    % set new camera position
    if ~isempty(newpos)
        cam.position=newpos;
    end;

    if ~isempty(newrot)
        cam.orientation=newrot;
    end
    
end

if redGuessWall == 1 && userdata.i == redGuessWallTime+feedbackPause

    %return cue search wall
    if trialType == 1 || trialType == 2
        wallOneTexture.url=fixedCueWall;
    elseif trialType == 3 || trialType == 4
        wallOneTexture.url=novelCueWall;
    end

    % return remaining search walls
    wallTwoTexture.url=blankWall2;
    wallThreeTexture.url=blankWall1;
    wallFourTexture.url=blankWall2;

    redGuessWall = 0;
end

% platform pause
if trialState == 2 && (pfFrame > (userdata.i - (pfPause*SR)))
    % hold trialState for duration of pause
    trialState = 2;

    if trialState == 2 && (pfFrame == (userdata.i - feedbackPause))
        
        %return cue search wall
        if currentTrialType == 1 || currentTrialType == 2
            wallOneTexture.url=fixedCueWall;
        elseif currentTrialType == 3 || currentTrialType == 4
            wallOneTexture.url=novelCueWall;
        end

        % return remaining search walls
        wallTwoTexture.url=blankWall2;
        wallThreeTexture.url=blankWall1;
        wallFourTexture.url=blankWall2;

    end

elseif trialState == 2 && (pfFrame == (userdata.i - (pfPause*SR)))

    if userdata.frameNumIter < maxFramesLow
        userdata.i = 1;
        trialState = 3;
        noTimeOut = 0;
        holdState=0;

        % remove previous feedback
        feedbackTran1.translation=[0 -150 -.25];
        feedbackTran2.translation=[0 -150 -.25];

        % set position and orientation
        cam.position=[0 -100 0];
        cam.orientation=[0 1 0 0];
        fixationCross.translation=[0 -100 -.25];
        fixationCross.rotation=[0 1 0 0];
        x=cam.position(3);
        y=cam.position(1);
        rot(4)=cam.orientation(4);

        restPause = round((restPauseLow + ((restPauseHigh-restPauseLow)*randn))*SR)+cuePause;

    elseif userdata.frameNumIter >= maxFramesLow
        endRun = 1;
    end

end

% determine novel platform position
% phase 1
if trialType == 3 && initialiseNovelPf1 == 0
    if atan2(y,x) >= novelTargetZoneLow && atan2(y,x) <= novelTargetZoneHigh ...
           && userdata.i < (maxTrialLength-(timeOutPause*SR)-delayFrames-1)
        initialiseNovelPf1 = 1;
        entryFrameNum=userdata.i;
    end
end
% phase 2
if trialType == 3 && initialiseNovelPf1 == 1
    if entryFrameNum == userdata.i-delayFrames 
        initialiseNovelPf2 = 1;
    end
end


% store new camera position
userdata.xyPath(userdata.frameNumIter,1:4)=[runNr x y rot(4)];

% store iterations and trial state
userdata.frameNumStore(userdata.frameNumIter,1)=userdata.frameNumIter;
userdata.trialStateStore(userdata.frameNumIter,1)=trialState;
userdata.trialStore(userdata.frameNumIter,1)=trial;
userdata.trialTypeStore(userdata.frameNumIter,1:3)=[trialType pfXNovel pfYNovel];


% store updated variables for next iteration
userdata.trial = trial;
userdata.trialState = trialState;
userdata.pfFrame = pfFrame;
userdata.spIterOver = spIterOver;
userdata.spIterNovel = spIterNovel;
userdata.pfIterNovel = pfIterNovel;
userdata.pfIterFindCount = pfIterFindCount;
userdata.holdState = holdState;
userdata.noTimeOut = noTimeOut;
userdata.pulseReg = pulseReg;
userdata.aPress = aPress;
userdata.probePhase = probePhase;
userdata.probePhaseOneComplete = probePhaseOneComplete;
userdata.restPause = restPause;
userdata.trialType = trialType;
userdata.currentTrialType = currentTrialType;
userdata.pressNr = pressNr;
userdata.endPress = endPress;
userdata.redGuessWall = redGuessWall;
userdata.redGuessWallTime = redGuessWallTime;
userdata.pfXNovel = pfXNovel;
userdata.pfYNovel = pfYNovel;
userdata.novelCueWall = novelCueWall;
userdata.initialiseNovelPf1 = initialiseNovelPf1;
userdata.initialiseNovelPf2 = initialiseNovelPf2;
userdata.entryFrameNum  = entryFrameNum;
userdata.novelPfSet = novelPfSet;

% display end of scan time
if maxFramesLow == userdata.frameNumIter
    disp([num2str((maxFramesLow/SR)/60) ' minutes'])
end

% stop run
if  endRun == 1
    stop(object)
    % close window
    close(userdata.w)
end

% store collected data
object.userdata=userdata;