clear all
vrclear
delete(timerfind)
clc
rand('twister',sum(100*clock))

% set root folder to current script folder
rootFolder='C:\Matlab\VRWM\VRWMcollection\vrwmScan1\';
mapFolder ='C:\Matlab\VRWM\VRWMmaps\';
cd (rootFolder)

% load parameter file
parameters=readFile(rootFolder,'parametersScan1.txt');

% create and open world and view
w=vrworld(parameters.worldname);
open(w)

% get nodes
cam=vrnode(w,'Camera');

% set camera
cam.fieldOfView=1.0;
cam.position=[0 -100 0];
cam.orientation=[0 1 0 0];

% hide cursor
%HideCursor

% open viewing window
v=view(w);

% adjust view
%set(v,'Fullscreen','on')
set(v,'NavPanel','none')
set(v,'AntiAliasing','on')

% construct waitTimer
waitTimer=timer('Name','prepare','ExecutionMode','singleShot','TimerFcn',@vrwmScan1_prepare_fcn);

% calculate maximum number of ticks
maxFramesLow=((parameters.runTime*60) * parameters.SR);
maxFramesHigh=((parameters.runTime*60) * parameters.SR) + (90*parameters.SR);

% construct Timer object
t=timer('Name','tick','ExecutionMode','fixedRate','Period',1/parameters.SR,'TasksToExecute',maxFramesHigh,'BusyMode','queue','TimerFcn',@vrwmScan1_tick_fcn,'StopFcn',@vrwmScan1_stop_fcn,'ErrorFcn','disp(''computer says no'')');

waitData.rootFolder=rootFolder;
waitData.mapFolder=mapFolder;
waitData.w=w;
waitData.v=v;
waitData.t=t;
waitData.maxFramesHigh=maxFramesHigh;
waitData.maxFramesLow=maxFramesLow;

% store experiment variables in userdata of waitTimer
waitTimer.userdata=waitData;

pause(.5);

% start waitTimer
start(waitTimer)
